#define COMPARE_ROW_DECL(NAME, OP, LEFT, RIGHT) \
\
extern void NAME ## _row_ ## LEFT ## _ ## RIGHT(char *Target, ml_array_dimension_t *LeftDimension, char *LeftData, ml_array_dimension_t *RightDimension, char *RightData);

#define COMPARE_ROW_LEFT_DECL_BASE(NAME, OP, LEFT) \
COMPARE_ROW_DECL(NAME, OP, LEFT, int8_t) \
COMPARE_ROW_DECL(NAME, OP, LEFT, uint8_t) \
COMPARE_ROW_DECL(NAME, OP, LEFT, int16_t) \
COMPARE_ROW_DECL(NAME, OP, LEFT, uint16_t) \
COMPARE_ROW_DECL(NAME, OP, LEFT, int32_t) \
COMPARE_ROW_DECL(NAME, OP, LEFT, uint32_t) \
COMPARE_ROW_DECL(NAME, OP, LEFT, int64_t) \
COMPARE_ROW_DECL(NAME, OP, LEFT, uint64_t) \
COMPARE_ROW_DECL(NAME, OP, LEFT, float) \
COMPARE_ROW_DECL(NAME, OP, LEFT, double)

#ifdef ML_COMPLEX

#define COMPARE_ROW_LEFT_DECL(NAME, OP, LEFT) \
COMPARE_ROW_LEFT_DECL_BASE(NAME, OP, LEFT) \
COMPARE_ROW_DECL(NAME, OP, LEFT, complex_float) \
COMPARE_ROW_DECL(NAME, OP, LEFT, complex_double)

#else

#define COMPARE_ROW_LEFT_DECL(NAME, OP, LEFT) \
COMPARE_ROW_LEFT_DECL_BASE(NAME, OP, LEFT)

#endif

#define COMPARE_ROW_LEFT_VALUE_DECL_BASE(NAME, OP) \
COMPARE_ROW_VALUE_DECL(NAME, OP, int8_t) \
COMPARE_ROW_VALUE_DECL(NAME, OP, uint8_t) \
COMPARE_ROW_VALUE_DECL(NAME, OP, int16_t) \
COMPARE_ROW_VALUE_DECL(NAME, OP, uint16_t) \
COMPARE_ROW_VALUE_DECL(NAME, OP, int32_t) \
COMPARE_ROW_VALUE_DECL(NAME, OP, uint32_t) \
COMPARE_ROW_VALUE_DECL(NAME, OP, int64_t) \
COMPARE_ROW_VALUE_DECL(NAME, OP, uint64_t) \
COMPARE_ROW_VALUE_DECL(NAME, OP, float) \
COMPARE_ROW_VALUE_DECL(NAME, OP, double)

#ifdef ML_COMPLEX

#define COMPARE_ROW_LEFT_VALUE_DECL(NAME, OP) \
COMPARE_ROW_LEFT_VALUE_DECL_BASE(NAME, OP) \
COMPARE_ROW_VALUE_DECL(NAME, OP, complex_float) \
COMPARE_ROW_VALUE_DECL(NAME, OP, complex_double)

#else

#define COMPARE_ROW_LEFT_VALUE_DECL(NAME, OP) \
COMPARE_ROW_LEFT_VALUE_DECL_BASE(NAME, OP)

#endif

#define COMPARE_ROW_OPS_DECL_BASE(NAME, OP) \
COMPARE_ROW_LEFT_DECL(NAME, OP, int8_t) \
COMPARE_ROW_LEFT_DECL(NAME, OP, uint8_t) \
COMPARE_ROW_LEFT_DECL(NAME, OP, int16_t) \
COMPARE_ROW_LEFT_DECL(NAME, OP, uint16_t) \
COMPARE_ROW_LEFT_DECL(NAME, OP, int32_t) \
COMPARE_ROW_LEFT_DECL(NAME, OP, uint32_t) \
COMPARE_ROW_LEFT_DECL(NAME, OP, int64_t) \
COMPARE_ROW_LEFT_DECL(NAME, OP, uint64_t) \
COMPARE_ROW_LEFT_DECL(NAME, OP, float) \
COMPARE_ROW_LEFT_DECL(NAME, OP, double)

#ifdef ML_COMPLEX

#define COMPARE_ROW_OPS_DECL(NAME, OP) \
COMPARE_ROW_OPS_DECL_BASE(NAME, OP) \
COMPARE_ROW_LEFT_DECL(NAME, OP, complex_float) \
COMPARE_ROW_LEFT_DECL(NAME, OP, complex_double)

#else

#define COMPARE_ROW_OPS_DECL(NAME, OP) \
COMPARE_ROW_OPS_DECL_BASE(NAME, OP)

#endif

COMPARE_ROW_OPS_DECL(eq, ==)
COMPARE_ROW_OPS_DECL(ne, !=)
COMPARE_ROW_OPS_DECL(lt, <)
COMPARE_ROW_OPS_DECL(gt, >)
COMPARE_ROW_OPS_DECL(le, <=)
COMPARE_ROW_OPS_DECL(ge, >=)
