#define UPDATE_ROW_DECL(NAME, TARGET, SOURCE) \
\
extern void NAME ## _row_ ## TARGET ## _ ## SOURCE(ml_array_dimension_t *TargetDimension, char *TargetData, ml_array_dimension_t *SourceDimension, char *SourceData);

#define UPDATE_ROW_VALUE_DECL(NAME, SOURCE) \
\
extern void NAME ## _row_value_ ## SOURCE(ml_array_dimension_t *TargetDimension, char *TargetData, ml_array_dimension_t *SourceDimension, char *SourceData);

#define UPDATE_ROW_DECL_VALUE(NAME, TARGET) \
\
extern void NAME ## _row_ ## TARGET ## _value(ml_array_dimension_t *TargetDimension, char *TargetData, ml_array_dimension_t *SourceDimension, char *SourceData);

#define UPDATE_ROW_VALUE_DECL_VALUE(NAME) \
\
extern void NAME ## _row_value_value(ml_array_dimension_t *TargetDimension, char *TargetData, ml_array_dimension_t *SourceDimension, char *SourceData);

#define UPDATE_ROW_TARGET_DECL_BASE(NAME, TARGET) \
UPDATE_ROW_DECL(NAME, TARGET, int8_t) \
UPDATE_ROW_DECL(NAME, TARGET, uint8_t) \
UPDATE_ROW_DECL(NAME, TARGET, int16_t) \
UPDATE_ROW_DECL(NAME, TARGET, uint16_t) \
UPDATE_ROW_DECL(NAME, TARGET, int32_t) \
UPDATE_ROW_DECL(NAME, TARGET, uint32_t) \
UPDATE_ROW_DECL(NAME, TARGET, int64_t) \
UPDATE_ROW_DECL(NAME, TARGET, uint64_t) \
UPDATE_ROW_DECL(NAME, TARGET, float) \
UPDATE_ROW_DECL(NAME, TARGET, double) \
UPDATE_ROW_DECL_VALUE(NAME, TARGET)

#ifdef ML_COMPLEX

#define UPDATE_ROW_TARGET_DECL(NAME, TARGET) \
UPDATE_ROW_TARGET_DECL_BASE(NAME, TARGET) \
UPDATE_ROW_DECL(NAME, TARGET, complex_float) \
UPDATE_ROW_DECL(NAME, TARGET, complex_double)

#else

#define UPDATE_ROW_TARGET_DECL(NAME, TARGET) \
UPDATE_ROW_TARGET_DECL_BASE(NAME, TARGET)

#endif

#define UPDATE_ROW_TARGET_VALUE_DECL_BASE(NAME) \
UPDATE_ROW_VALUE_DECL(NAME, int8_t) \
UPDATE_ROW_VALUE_DECL(NAME, uint8_t) \
UPDATE_ROW_VALUE_DECL(NAME, int16_t) \
UPDATE_ROW_VALUE_DECL(NAME, uint16_t) \
UPDATE_ROW_VALUE_DECL(NAME, int32_t) \
UPDATE_ROW_VALUE_DECL(NAME, uint32_t) \
UPDATE_ROW_VALUE_DECL(NAME, int64_t) \
UPDATE_ROW_VALUE_DECL(NAME, uint64_t) \
UPDATE_ROW_VALUE_DECL(NAME, float) \
UPDATE_ROW_VALUE_DECL(NAME, double) \
UPDATE_ROW_VALUE_DECL_VALUE(NAME)

#ifdef ML_COMPLEX

#define UPDATE_ROW_TARGET_VALUE_DECL(NAME) \
UPDATE_ROW_TARGET_VALUE_DECL_BASE(NAME) \
UPDATE_ROW_VALUE_DECL(NAME, complex_float) \
UPDATE_ROW_VALUE_DECL(NAME, complex_double)

#else

#define UPDATE_ROW_TARGET_VALUE_DECL(NAME) \
UPDATE_ROW_TARGET_VALUE_DECL_BASE(NAME)

#endif

#define UPDATE_ROW_OPS_DECL_BASE(NAME) \
UPDATE_ROW_TARGET_DECL(NAME, int8_t) \
UPDATE_ROW_TARGET_DECL(NAME, uint8_t) \
UPDATE_ROW_TARGET_DECL(NAME, int16_t) \
UPDATE_ROW_TARGET_DECL(NAME, uint16_t) \
UPDATE_ROW_TARGET_DECL(NAME, int32_t) \
UPDATE_ROW_TARGET_DECL(NAME, uint32_t) \
UPDATE_ROW_TARGET_DECL(NAME, int64_t) \
UPDATE_ROW_TARGET_DECL(NAME, uint64_t) \
UPDATE_ROW_TARGET_DECL(NAME, float) \
UPDATE_ROW_TARGET_DECL(NAME, double) \
UPDATE_ROW_TARGET_VALUE_DECL(NAME)

#ifdef ML_COMPLEX

#define UPDATE_ROW_OPS_DECL(NAME) \
UPDATE_ROW_OPS_DECL_BASE(NAME) \
UPDATE_ROW_TARGET_DECL(NAME, complex_float) \
UPDATE_ROW_TARGET_DECL(NAME, complex_double)

#else

#define UPDATE_ROW_OPS_DECL(NAME) \
UPDATE_ROW_OPS_DECL_BASE(NAME)

#endif

UPDATE_ROW_OPS_DECL(set)
UPDATE_ROW_OPS_DECL(add)
UPDATE_ROW_OPS_DECL(mul)
UPDATE_ROW_OPS_DECL(sub)
UPDATE_ROW_OPS_DECL(rsub)
UPDATE_ROW_OPS_DECL(div)
UPDATE_ROW_OPS_DECL(rdiv)
